<?php
// $Id: inline_ajax_search.inc,v 1.1.2.4 2010/03/23 11:37:24 fabianderijk Exp $
/**
 * @file
 * The file that holds the function that does the search
 */
function _inline_ajax_search($str, $type) {
  switch ($type) {
    case 'page':
      $ext = '_page';
      break;
    case 'default':
      $ext = '';
      break;
  }
  $uselucene = module_exists('luceneapi') && module_exists('luceneapi_node') && variable_get('inline_ajax_use_lucene' . $ext, 0) == 1 ? TRUE : FALSE;
  $str = inline_ajax_search_string_format($str);
  $snippet = variable_get('inline_ajax_search_snippet' . $ext, 0);
  $types = array();
  $nr = variable_get('inline_ajax_search_count' . $ext, 10);
  if (count($types) > 0) {
    $str .= ' type:';
    foreach ($types as $type) {
      if (!empty($type)) {
        $str .= $type . ',';
      }
    }
  }
  if ($uselucene) {
    $results = luceneapi_node_search('search', $str);
  }
    else {
      $results = inline_ajax_search_search('search', $str);
    }
  $count = count($results);
  if ($count > 0) {
    $n = 0;
    foreach ($results as $result) {
      if ($n < $nr) {
        switch ($snippet) {
          case 0: // show only title
            $ret .= '<div class="searchresult"><h3>' . l($result['title'], $result['link']) . '</h3>';
            break;
          case 1: // show title and snippet
            $ret .= '<div class="searchresult"><h3>' . l($result['title'], $result['link']) . '</h3>';
            $ret .= '<span>' . $result['snippet'] . '</span>';
            break;
          case 2: // show teaser
            $nid = $result['node']->nid;
            $node = node_view(node_load(array('nid' => $nid)), TRUE, FALSE);
            $ret .= '<div class="searchresult">' . $node;
            break;
      }
        $ret .= '</div>';
        $n++;
      }
    }
    if ($count > $nr && variable_get('inline_ajax_show_more' . $ext, 0) == 1) {
      if ($uselucene) {
        $p = 'search/luceneapi_node/' . $str;
      }
        else {
          $p = 'search/node/' . $str;
        }
      $ret .= '<div class="moreresults">' . l(t('Found') . ' ' . $count . ' ' . t('results. ') . t('Show more >>'), $p) . '</div>';
    }
  }
    else {
      $ret = '<div class="searchresult noresults">' . t('No results were found. Try with a different term.') . '</div>';
    }
  return drupal_json(array('answer' => $ret));
}